#include "cm0scs.h"

/* $B3d$j9~$_%Y%/%?(B */

	.section .vector,"ax"
	.thumb
	.align 0

	.long	_main_stack		// MSP default value
	.long	reset_entry + 1		//  1: Reset
	.long	intr_entry + 1		//  2: NMI
	.long	hardfault_entry + 1	//  3: HardFault
	.long	intr_entry + 1		//  4: reserved
	.long	intr_entry + 1		//  5: reserved
	.long	intr_entry + 1		//  6: reserved
	.long	intr_entry + 1		//  7: reserved
	.long	intr_entry + 1		//  8: reserved
	.long	intr_entry + 1		//  9: reserved
	.long	intr_entry + 1		// 10: reserved
	.long	svc_entry + 1		// 11: SVCall
	.long	intr_entry + 1		// 12: reserved
	.long	intr_entry + 1		// 13: reserved
	.long	pendsv_entry + 1	// 14: PendSV
	.long	intr_entry + 1		// 15: SysTick
	.long	intr_entry + 1		// 16: External Interrupt(0)
	.long	intr_entry + 1		// 17: External Interrupt(1)
	.long	intr_entry + 1		// 18: External Interrupt(2)
	.long	intr_entry + 1		// 19: External Interrupt(3)
	.long	intr_entry + 1		// 20: External Interrupt(4)
	.long	intr_entry + 1		// 21: External Interrupt(5)
	.long	intr_entry + 1		// 22: External Interrupt(6)
	.long	intr_entry + 1		// 23: External Interrupt(7)
	.long	intr_entry + 1		// 24: External Interrupt(8)
	.long	intr_entry + 1		// 25: External Interrupt(9)
	.long	intr_entry + 1		// 26: External Interrupt(10)
	.long	intr_entry + 1		// 27: External Interrupt(11)
	.long	intr_entry + 1		// 28: External Interrupt(12)
	.long	intr_entry + 1		// 29: External Interrupt(13)
	.long	intr_entry + 1		// 30: External Interrupt(14)
	.long	intr_entry + 1		// 31: External Interrupt(15)
	.long	intr_entry + 1		// 32: External Interrupt(16)
	.long	intr_entry + 1		// 33: External Interrupt(17)
	.long	intr_entry + 1		// 34: External Interrupt(18)
	.long	intr_entry + 1		// 35: External Interrupt(19)
	.long	intr_entry + 1		// 36: External Interrupt(20)
	.long	intr_entry + 1		// 37: External Interrupt(21)
	.long	intr_entry + 1		// 38: External Interrupt(22)
	.long	intr_entry + 1		// 39: External Interrupt(23)
	.long	intr_entry + 1		// 40: External Interrupt(24)
	.long	intr_entry + 1		// 41: External Interrupt(25)
	.long	intr_entry + 1		// 42: External Interrupt(26)
	.long	intr_entry + 1		// 43: External Interrupt(27)
	.long	intr_entry + 1		// 44: External Interrupt(28)
	.long	intr_entry + 1		// 45: External Interrupt(29)
	.long	intr_entry + 1		// 46: External Interrupt(30)
	.long	intr_entry + 1		// 47: External Interrupt(31)
	.long	intr_entry + 1		// 48: External Interrupt(32)
	.long	intr_entry + 1		// 49: External Interrupt(33)
	.long	intr_entry + 1		// 50: External Interrupt(34)
	.long	intr_entry + 1		// 51: External Interrupt(35)
	.long	intr_entry + 1		// 52: External Interrupt(36)
	.long	intr_entry + 1		// 53: External Interrupt(37)
	.long	intr_entry + 1		// 54: External Interrupt(38)
	.long	intr_entry + 1		// 55: External Interrupt(39)
	.long	intr_entry + 1		// 56: External Interrupt(40)
	.long	intr_entry + 1		// 57: External Interrupt(41)
	.long	intr_entry + 1		// 58: External Interrupt(42)
	.long	intr_entry + 1		// 59: External Interrupt(43)
	.long	intr_entry + 1		// 60: External Interrupt(44)
	.long	intr_entry + 1		// 61: External Interrupt(45)
	.long	intr_entry + 1		// 62: External Interrupt(46)
	.long	intr_entry + 1		// 63: External Interrupt(47)

/* $B%9%?!<%H%"%C%W(B */

	.section .text
	.thumb
	.align 0
	.global reset_entry

reset_entry:
	/* $B3F<o%9%?%C%/$r=i4|2=(B */
	ldr	r0, =_process_stack
	msr	psp, r0
	mov	r0, #2
	msr	control, r0		// use PSP in Thread mode

	/* $B%\!<%I8GM-$N@_Dj(B */
	bl	board_setup

	/* .data$B$N=i4|2=(B */
data_init:
	ldr	r1, =_data_org
	ldr	r2, =_data_start
	ldr	r3, =_data_end
	cmp	r2, r3
	beq	bss_init
data_loop:
	ldrb	r0, [r1]
	add	r1, r1, #1
	strb	r0, [r2]
	add	r2, r2, #1
	cmp	r2, r3
	bne	data_loop

	/* .bss$B$N=i4|2=(B */
bss_init:
	mov	r0, #0
	ldr	r2, =_bss_start
	ldr	r3, =_bss_end
	cmp	r2, r3
	beq	start_main
bss_loop:
	strb	r0, [r2]
	add	r2, r2, #1
	cmp	r2, r3
	bne	bss_loop

	/* $B%a%$%s(B */
start_main:
	mov	r0, #0
	bl	serial_init	// $B%G%P%C%0MQ%7%j%"%k%]!<%H$r=i4|2=(B
	bl	main
	b	die

	/* $BK=AvKI;_MQ$NL58B%k!<%W(B */
die:
	b	die

	.pool

/*
 * $B3d$j9~$_%(%s%H%j(B
 *
 * IPSR$B$+$i3d$j9~$_%Y%/%?HV9f$r<hF@$7$F!"%O%s%I%i$XEO$9!#(B
 */
intr_entry:
	mrs	r0, ipsr
	b	interrupt

/*
 * HardFault$B%(%s%H%j(B
 *
 * $B4JC1$J%G%P%C%0>pJs$rI=<($G$-$k$h$&!"Nc30H/@8;~$N(BSP$B$r<hF@$7$F(B
 * $B$=$N(BSP$B$r(BHardFault$B%O%s%I%i$KEO$9!#(B
 *
 *	     +-------------+
 *	+  0 | R0          |	$B%O!<%I%&%'%"$K$h$k<+F0J]B8(B/$BB`Hr(B
 *	+  4 | R1          |
 *	+  8 | R2          |
 *	+ 12 | R3          |
 *	+ 16 | R12         |
 *	+ 20 | R14(LR)     |
 *	+ 24 | R15(PC)     |
 *	+ 28 | xPSR        |
 *	     +-------------+
 */
hardfault_entry:
	/* LR$B$KF~$C$F$$$k(BEXC_RETURN[3:0]$B$NCM$+$i!"(BMSP/PSP$B$rH=Dj(B */
	mrs	r0, msp
	mov	r1, lr
	lsl	r1, r1, #28
	lsr	r1, r1, #28	// r0 &= 0x0000000f
	cmp	r1, #0xd
	bne	1f
	mrs	r0, psp
1:
	/* HardFault$B%O%s%I%i$r8F$S=P$7(B */
	bl	hardfault

	/* HardFault$B%O%s%I%i$NLa$jCM$K1~$8!"F0:n7QB3(B/$BDd;_(B */
	cmp	r0, #0
	beq	intr_entry
	b	die

/*
 * SVC$B%(%s%H%j(B
 *
 * SVC$BL?Na$+$i%Y%/%?HV9f$r<hF@$7$F!"%O%s%I%i$XEO$9!#(B
 * SVC$BL?Na$O!"%9%?%C%/$KJ]B8$5$l$?(B(PC-2)$B$KB8:_$9$k!#(B
 */
svc_entry:
	/* LR$B$KF~$C$F$$$k(BEXC_RETURN[3:0]$B$NCM$+$i!"(BMSP/PSP$B$rH=Dj(B */
	mrs	r0, msp
	mov	r1, lr
	lsl	r1, r1, #28
	lsr	r1, r1, #28	// r0 &= 0x0000000f
	cmp	r1, #0xd
	bne	1f
	mrs	r0, psp
1:
	/* $B%9%?%C%/>e$+$i(BPC$B$r<hF@$7!"(BSVC$BL?Na$NB8:_$9$k%"%I%l%9$KJd@5(B */
	ldr	r0, [r0, #24]
	sub	r0, r0, #2

	/* SVC$BL?Na$K5-=R$5$l$?%Y%/%?HV9f$r<hF@(B $B"((Blittle-endian$B$rA0Ds(B */
	ldrb	r0, [r0]
	b	interrupt

/*
 * $B%3%s%F%-%9%H$N%l%$%"%&%H(B
 *
 * $B0J2<$N=gHV$G%3%s%F%-%9%H!J%l%8%9%?!K$rJ]B8$9$k!#(B
 *
 *	     +-------------+
 *	+  0 | R8          |
 *	+  4 | R9          |
 *	+  8 | R10         |
 *	+ 12 | R11         |
 *	+ 16 | R4          |
 *	+ 20 | R5          |
 *	+ 24 | R6          |
 *	+ 28 | R7          |
 *	+    +=============+
 *	+ 32 | R0          |	$B%O!<%I%&%'%"$K$h$k<+F0J]B8(B/$BB`Hr(B
 *	+ 36 | R1          |
 *	+ 40 | R2          |
 *	+ 44 | R3          |
 *	+ 48 | R12         |
 *	+ 52 | R14(LR)     |
 *	+ 56 | R15(PC)     |
 *	+ 60 | xPSR        |
 *	     +-------------+
 */

/* $B%G%#%9%Q%C%A%c!J(BPendSV$B%O%s%I%i$H$7$F<BAu!K(B */
pendsv_entry:
	// $B%O!<%I%&%'%"$K$h$k<+F0J]B8(B/$BB`HrBP>]30$N%l%8%9%?$O!"(B
	// ARM ABI$B$NDj5A$K$h$j%W%m%7!<%8%cFb$G$NGK2u$r6X;_$5$l$F$$$k!#(B
	// $B8N$K$3$3$KE~C#$7$?:]$O!"Nc30H/@8;~$NFbMF$,$=$N$^$^J];}$5$l$F$$$k!#(B

	cpsid	i

	/* PendSV$BMW5a$r%/%j%"(B */
	ldr	r1, =ICSR
	ldr	r2, =0x08000000	// PENDSVCLR
	ldr	r3, [r1]
	orr	r3, r3, r2
	str	r2, [r1]
	
	/* $B%3%s%F%-%9%H%9%$%C%A$NI,MW@-$r%A%'%C%/(B */
	// running_context: $B8=:_<B9TCf$N(B($B8E$$(B)$B%?%9%/$N(BTCB
	// current: $B$3$l$+$i<B9T$9$k!"(B($B?7$7$$(B)$B%?%9%/$N(BTCB
	ldr	r2, =running_context
	ldr	r0, [r2]
	ldr	r1, =current
	ldr	r1, [r1]
	cmp	r0, r1
	beq	no_dispatch
	str	r1, [r2]		// running_context$B$NFbMF$r99?7(B
					// $B"(85$NFbMF$O(Br0$B$KJ]B8$5$l$F$$$k(B
	ldr	r3, =offsetof_kz_context
	ldr	r3, [r3]
	add	r0, r0, r3		// r0: &(running_context->sp)
	add	r1, r1, r3		// r1: &(current->sp)

	/* process stack$B$K%3%s%F%-%9%H$rJ]B8(B */
	mrs	r3, psp
	sub	r3, r3, #0x10
	stmia	r3!, {r4-r7}
	mov	r4, r8
	mov	r5, r9
	mov	r6, r10
	mov	r7, r11
	sub	r3, r3, #0x20
	stmia	r3!, {r4-r7}
	sub	r3, r3, #0x10
	str	r3, [r0]

	/* process stack$B$+$i%3%s%F%-%9%H$rI|85(B */
	ldr	r3, [r1]
	ldmia	r3!, {r4-r7}
	mov	r8, r4
	mov	r9, r5
	mov	r10, r6
	mov	r11, r7
	ldmia	r3!, {r4-r7}
	msr	psp, r3

no_dispatch:
	cpsie	i
	bx	lr

/* $B%G%#%9%Q%C%AMW5a$rH/9T(B */
	.global dispatch
dispatch:
	cpsid	i
	ldr	r1, =ICSR
	ldr	r2, =0x10000000	// PENDSVSET
	ldr	r3, [r1]
	orr	r3, r3, r2
	str	r2, [r1]
	cpsie	i
	bx	lr

	.pool

	.section .data
	.align 0

running_context:
	.long	0
